//---
// ft.all-tests: List of all test structures defined by modules
//---

#ifndef _FT_ALL_TESTS_H_
#define _FT_ALL_TESTS_H_

#include <ft/test.h>

/* ctype */
extern ft_test ft_ctype_classes;
extern ft_test ft_ctype_conversion;

/* inttypes */
extern ft_test ft_inttypes_sizes;
extern ft_test ft_inttypes_functions;

/* setjmp */
extern ft_test ft_setjmp_simple;
extern ft_test ft_setjmp_massive;
extern ft_test ft_setjmp_interrupt;

/* signal */
extern ft_test ft_signal_signal;

/* stdio */
extern ft_test ft_stdio_printf_basics;
extern ft_test ft_stdio_printf_formats;
extern ft_test ft_stdio_printf_fp;
extern ft_test ft_stdio_open;
extern ft_test ft_stdio_simple_read;
extern ft_test ft_stdio_simple_write;
extern ft_test ft_stdio_line_buffering;
extern ft_test ft_stdio_update_ungetc;
extern ft_test ft_stdio_append;
extern ft_test ft_stdio_fdopen;
extern ft_test ft_stdio_write_chars;
extern ft_test ft_stdio_read_chars;
extern ft_test ft_stdio_stdstreams;
extern ft_test ft_stdio_getdelim;

/* stdlib */
extern ft_test ft_stdlib_arith;
extern ft_test ft_stdlib_sizes;
extern ft_test ft_stdlib_llconv;
extern ft_test ft_stdlib_lconv;
extern ft_test ft_stdlib_fpconv;
extern ft_test ft_stdlib_rand;
extern ft_test ft_stdlib_exit;
extern ft_test ft_stdlib__Exit;
extern ft_test ft_stdlib_abort;

/* string */
extern ft_test ft_string_memset;
extern ft_test ft_string_memcpy;
extern ft_test ft_string_memmove;
extern ft_test ft_string_memcmp;
extern ft_test ft_string_memchr;
extern ft_test ft_string_strlen;
extern ft_test ft_string_naive;
extern ft_test ft_string_strerror;

/* time */
extern ft_test ft_time_clock;
extern ft_test ft_time_functions;

/* dirent */
extern ft_test ft_dirent_glob;
extern ft_test ft_dirent_open_folders;

/* fcntl */
extern ft_test ft_fcntl_open;

/* unistd */
extern ft_test ft_unistd_path;
extern ft_test ft_unistd_simple_write;
extern ft_test ft_unistd_write_odd;
extern ft_test ft_unistd_simple_read;
extern ft_test ft_unistd_seek_patterns;
extern ft_test ft_unistd_folders;

/* sys/stat */
extern ft_test ft_sysstat_stat;

#endif /* _FT_ALL_TESTS_H_ */
