#include <inttypes.h>
#include <stddef.h>
#include <ft/test.h>
#include <ft/all-tests.h>

static void _inttypes_sizes(ft_test *t)
{
	ft_assert(t, sizeof(int8_t) == sizeof(uint8_t));
	ft_assert(t, sizeof(int16_t) == sizeof(uint16_t));
	ft_assert(t, sizeof(int32_t) == sizeof(uint32_t));
	ft_assert(t, sizeof(int64_t) == sizeof(uint64_t));
	ft_assert(t, sizeof(int_least8_t) == sizeof(uint_least8_t));
	ft_assert(t, sizeof(int_least16_t) == sizeof(uint_least16_t));
	ft_assert(t, sizeof(int_least32_t) == sizeof(uint_least32_t));
	ft_assert(t, sizeof(int_least64_t) == sizeof(uint_least64_t));
	ft_assert(t, sizeof(int_fast8_t) == sizeof(uint_fast8_t));
	ft_assert(t, sizeof(int_fast16_t) == sizeof(uint_fast16_t));
	ft_assert(t, sizeof(int_fast32_t) == sizeof(uint_fast32_t));
	ft_assert(t, sizeof(int_fast64_t) == sizeof(uint_fast64_t));
	ft_assert(t, sizeof(intmax_t) == sizeof(uintmax_t));
	ft_assert(t, sizeof(intptr_t) == sizeof(uintptr_t));

	/* TODO: Use %zu once available in *printf */
	ft_log(t, "Size of integer types:\n\n");

	ft_log(t, " %d  int8_t\n", (int)sizeof(uint8_t));
	ft_log(t, " %d  int16_t\n", (int)sizeof(uint16_t));
	ft_log(t, " %d  int32_t\n", (int)sizeof(uint32_t));
	ft_log(t, " %d  int64_t\n\n", (int)sizeof(uint64_t));

	ft_log(t, " %d  int_least8_t\n", (int)sizeof(uint_least8_t));
	ft_log(t, " %d  int_least16_t\n", (int)sizeof(uint_least16_t));
	ft_log(t, " %d  int_least32_t\n", (int)sizeof(uint_least32_t));
	ft_log(t, " %d  int_least64_t\n\n", (int)sizeof(uint_least64_t));

	ft_log(t, " %d  int_fast8_t\n", (int)sizeof(uint_fast8_t));
	ft_log(t, " %d  int_fast16_t\n", (int)sizeof(uint_fast16_t));
	ft_log(t, " %d  int_fast32_t\n", (int)sizeof(uint_fast32_t));
	ft_log(t, " %d  int_fast64_t\n\n", (int)sizeof(uint_fast64_t));

	ft_log(t, " %d  intmax_t\n", (int)sizeof(uintmax_t));
	ft_log(t, " %d  intptr_t\n", (int)sizeof(uintptr_t));
	ft_log(t, " %d  size_t\n", (int)sizeof(size_t));
}

ft_test ft_inttypes_sizes = {
	.name = "Size of integer types",
	.function = _inttypes_sizes,
};
